using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplicationDataSet01
{
    public partial class DataSetForm01 : Form
    {
        public DataSetForm01()
        {
            InitializeComponent();
        }

        // flyttet til klassen i forhold til undervisningen s dataset "overlever knap"
        private System.Data.DataSet dataset = new DataSet("Varesalg");

        // indlser vare-tabel fra database til dataset
        private void hentVaretabel()
        {
            System.Data.OleDb.OleDbConnection con;
            string connectionName = "Provider=Microsoft.Jet.OLEDB.4.0;"
                                   + @"Data Source=..\..\..\Varesalg.mdb;"
                                   + "Jet OLEDB:Database Password=;";
            con = new System.Data.OleDb.OleDbConnection(connectionName);

            // lav en ny datatable og fyld det med data fra database-tabel
            // Til formlet bruges en DataAdapter
            // For at fylde i en table m man bruge den konkrete klasse,
            // da interface kun tillader at fylde direkte i dataset
            con.Open();
            string sql = "Select * from Vare";
            System.Data.OleDb.OleDbDataAdapter vareDataAdapter
                    = new System.Data.OleDb.OleDbDataAdapter(sql, con);

            DataTable vareDataTable = new DataTable("Vare");
            vareDataAdapter.Fill(vareDataTable);
            con.Close();

            // tilfj tabel til dataset
            dataset.Tables.Add(vareDataTable);
            if (dataset.HasErrors)
                dataset.RejectChanges();
            else
                dataset.AcceptChanges();

            textBoxLog.AppendText("Vare tabel indlst\r\n");
        }

        // tilsvarende med kunde-tabel fra database til dataset
        private void hentKundetabel()
        {
            System.Data.OleDb.OleDbConnection con;
            string connectionName = "Provider=Microsoft.Jet.OLEDB.4.0;"
                                   + @"Data Source=..\..\..\Varesalg.mdb;"
                                   + "Jet OLEDB:Database Password=;";
            con = new System.Data.OleDb.OleDbConnection(connectionName);

            // lav en ny datatable og fyld det med data fra database-tabel
            // Til formlet bruges en DataAdapter
            // For at fylde i en table m man bruge den konkrete klasse,
            // da interface kun tillader at fylde direkte i dataset
            con.Open();
            string sql = "Select * from Kunde";
            System.Data.OleDb.OleDbDataAdapter kundeDataAdapter
                = new System.Data.OleDb.OleDbDataAdapter(sql, con);

            DataTable kundeDataTable = new DataTable("Kunde");
            kundeDataAdapter.Fill(kundeDataTable);
            con.Close();

            // tilfj tabel til dataset
            dataset.Tables.Add(kundeDataTable);
            if (dataset.HasErrors)
                dataset.RejectChanges();
            else
                dataset.AcceptChanges();

            textBoxLog.AppendText("Kunde tabel indlst\r\n");
        }

        // viser hvordan dataset/datatable bruges direkte
        private void visVareDataTable()
        {
            DataTable vareTable = dataset.Tables["Vare"];
            if (vareTable == null) return;      // ikke "indlst"

            // hent og udskriv kolonnernes navne (felt-navne)
            foreach (DataColumn col in vareTable.Columns)
            {
                textBoxLog.AppendText( col.ColumnName + " ");
            }
            textBoxLog.AppendText("\r\n");

            // hent og udskriv rkker (felt-indhold)
            foreach (DataRow row in vareTable.Rows)
            {
                textBoxLog.AppendText( row["id"] + " ");
                textBoxLog.AppendText( row["betegnelse"] + " ");
                textBoxLog.AppendText("\r\n");
            }
        }

        private void opdaterDataset()
        {
            if (!dataset.HasChanges()) return;
            System.Data.OleDb.OleDbConnection con;
            string connectionName = "Provider=Microsoft.Jet.OLEDB.4.0;"
                                   + @"Data Source=..\..\..\Varesalg.mdb;"
                                   + "Jet OLEDB:Database Password=;";
            con = new System.Data.OleDb.OleDbConnection(connectionName);

            con.Open();

            System.Data.DataTable vareTable = dataset.Tables["Vare"];
            if (vareTable != null)
            {
                string sql = "Select * from Vare";
                System.Data.OleDb.OleDbDataAdapter vareDataAdapter
                        = new System.Data.OleDb.OleDbDataAdapter(sql, con);
                System.Data.OleDb.OleDbCommandBuilder cmdBuild =
                    new System.Data.OleDb.OleDbCommandBuilder(vareDataAdapter);
                vareDataAdapter.Update(vareTable);
                vareTable.AcceptChanges();
            }

            System.Data.DataTable kundeTable = dataset.Tables["Kunde"];
            if (kundeTable != null)
            {
                string sql = "Select * from Kunde";
                System.Data.OleDb.OleDbDataAdapter kundeDataAdapter
                        = new System.Data.OleDb.OleDbDataAdapter(sql, con);
                System.Data.OleDb.OleDbCommandBuilder cmdBuild =
                    new System.Data.OleDb.OleDbCommandBuilder(kundeDataAdapter);
                kundeDataAdapter.Update(kundeTable);
                kundeTable.AcceptChanges();
            }
            
            con.Close();
            textBoxLog.AppendText("Dataset opdateret\r\n");
        }

        // viser hvordan man kan vise en datatable i et datagrid
        private void visDataTableGrid()
        {
            DataTable dataTable;
            if (checkBoxKunder.Checked)
                dataTable = dataset.Tables["Kunde"];
            else
                dataTable = dataset.Tables["Vare"];
            if (dataTable == null) return;      // ikke "indlst"
            dataGridView1.DataSource = dataTable;
        }

        // viser hvordan man kan lave et DataView vise det i et datagrid
        private void visDataViewGrid()
        {
            DataTable dataTable = dataset.Tables["Kunde"];
            if (dataTable == null) return;      // ikke "indlst"
            DataView dataView = new DataView(dataTable, "Navn like '*han*'", "", DataViewRowState.CurrentRows);
            dataGridView1.DataSource = dataView;
        }

        private void buttonHentDataset_Click(object sender, EventArgs e)
        {
            dataset = new DataSet("Varesalg");
            hentVaretabel();
            hentKundetabel();
        }

        private void buttonVisDataTable_Click(object sender, EventArgs e)
        {
            visVareDataTable();
        }

        private void buttonVisDataTableGrid_Click(object sender, EventArgs e)
        {
            visDataTableGrid();
        }

        private void buttonKundeView_Click(object sender, EventArgs e)
        {
            visDataViewGrid();
        }

        private void buttonOpdater_Click(object sender, EventArgs e)
        {
            opdaterDataset();
        }

    }
}